<?php

/**
* @desc NavItems are objects that are returned as
* part of a NavBlock.  You can make use the formalized
* form of a NavItem by filling out title, link, and icon 
* or you can fill in the html field which will override
* the other fields.   
*/
class NavItem
{
    public $title = '';
    public $link = '';
    public $icon = '';
    
    public $html = '';
}

/**
* @desc The NavBlock is used to communicate data concerning
* what will appear in a navigation area.  A block is made up 
* of a title, some html (optional) and an array of NavItems
*/
class NavBlock
{           
    /** The title of the block */
    public $title = '';
    
    /** True to show the title, false to hide it */
    public $showTitle = true;
    
    /** An array of NavItem objects */
    public $items = array();
    
    /** The html to display below the title but above the items */
    public $html = '';
}

?>
