<?php

/**
 * @desc Anytime an email is sent out, the from address below
 * will be used.
 */
define ('AUTOMATED_EMAIL_FROM','noreply@iwonderdesigns.com');

/**
 * @desc Indicates which language to use when displaying text
 * to the user.  This will only affect dynamic strings that the 
 * nexus engine generates.  Static text can only be modified in the
 * active theme's files.
 */
define ('DEFAULT_LANGUAGE','en');

/**
 * @desc The theme is the face of Nexus.  Themes in Nexus are 
 * pretty sophisticated and include much of the asynchronous
 * behaviour, not just the look.  So, it's best not to change
 * it unless you copy the original and edit the copy.
 */
define ('DEFAULT_THEME','default');

/**
 * You only need to change this if you are running more than one 
 * 	nexus deployment on the same server.
 */
define ('DEPLOYMENT_NAME','dev');

/**
 * This sets the maximum size of all the documents in your library
 *	This does not include FileBox documents.
 */
define ('MAX_STORAGE_IN_MB', 2000);

/**
 * This is used when accessing Nexus from another
 * application on the same host via the bridge.  
 * It indicates the URL to the root of the nexus
 * install on the host computer.
 */
define ('IW_CONFIGURABLE_URL','http://localhost/share');

/**
 * This is used when accessing Nexus from another
 * application on the same host via the bridge.  
 * It indicates the relative path from that application's
 * main script files to the Nexus root.
 */
define ('IW_CONFIGURABLE_RELPATH','');


/**
 * If this is set to true then phpMailer is used
 * to send and receive email via specified SMTP server, otherwise
 * php's mail function is used and must be setup correctly
 * in your server php.ini file.
 */
define ('SMTP_ENABLED',false);

/**
 * The hostname or IP address of the SMTP server to 
 * connect to to send emails.
 */
define ('SMTP_HOST','');

/**
 * The SMTP port on the given server
 */
define ('SMTP_PORT',25);

/**
 * The username (if auth required) of the SMTP server to 
 * connect to to send emails.
 */
define ('SMTP_USERNAME','');

/**
 * The password (if auth required) of the SMTP server to 
 * connect to to send emails.
 */
define ('SMTP_PASSWORD','');

/**
 * @desc Set this to true if you want to see warnings and
 * non-fatal errors that occur during script execution. 
 * This will also turn on various checks and outputs that 
 * normally wouldn't be shown. Default is 'false'
 *                                               
 */
if (!defined('IW_DEBUG')) define('IW_DEBUG',false);

/**
 * Sets this to true to log all SQL queries made to a text file
 */
if (!defined('LOG_SQL')) define('LOG_SQL',false);

/**
 * Log PHP errors to an application log file (useful if you do not want to turn on
 * IW_DEBUG but still want to see PHP errors
 */
if (!defined('IW_LOG_PHP_ERRORS')) define ('IW_LOG_PHP_ERRORS',false);

/**
* @desc If set to true a script 'time to execute' message will appear below content area.
*/
if (!defined('EXEC_TIME')) define('EXEC_TIME',false);

?>
