<?php
/*
 * Nexus is a web-based file management application.
 * Copyright (C) 2007 Karim Shehadeh
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class iwPage extends iwObject
{
	protected $_arguments;	
	protected $_formArguments;
	protected $_content;
	protected $_smarty = array();

	public function addContent ($content)
	{
		$this->_content .= $content;
	}
	
	public function addSmartyVariable ($name, $value)
	{
		$this->_smarty[$name] = $value;
	}
	
	public function getSmartyVariable ($name)
	{
		if (isset ($this->_smarty[$name]))
		{
			return $this->_smarty[$name];
		}
		
		return false;
	}
	
	public function getSmartyVariables ()
	{
		return $this->_smarty;
	}
	
	public function setFormArguments ($arguments)
	{
		$this->_formArguments = $arguments;
	}

	public function getFormArguments ()
	{
		return $this->_formArguments;
	}
	
	public function setArguments ($arguments)
	{
		$this->_arguments = $arguments;
	}

	public function getArguments ()
	{
		return $this->_arguments;
	}
	
	public function authorize ()
	{
		die ("iwPage::authorize --> This MUST be overridden");
	}		
	
	public function getTemplate ()
	{
		die ("iwPage::getTemplate --> This MUST be overridden");
	}

	public function display ()
	{
		$this->addSmartyVariable('content',$this->_content);
	}	
	
	public function haveUrlArgument ($arg)
	{
		if (isset ($this->_arguments[$arg]))
		{
			return true;
		}
		return false;
	}
	
	public function getUrlArgument ($arg,$default='')
	{
		if ($this->haveUrlArgument($arg))
		{
			return $this->_arguments[$arg];
		}
		
		return $default;
	}

	public function haveFormArgument ($arg)
	{
		if (isset ($this->_formArguments[$arg]))
		{
			return true;
		}
		return false;
	}

	public function getCleanFormArgument ($arg,$default='')
	{
		$value = $this->getFormArgument($arg,$default);
		$cleaner = new HTML_Safe();
		return $cleaner->parse($value);
	}	
	
	public function getFormArgument ($arg,$default='')
	{
		if ($this->haveFormArgument($arg))
		{
			return $this->_formArguments[$arg];
		}
		
		return $default;
	}	
	
}

?>
