<?php
/*
 * Nexus is a web-based file management application.
 * Copyright (C) 2007 Karim Shehadeh
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


class shFormAttribute extends iwForm
{
	public function getFormAction()
	{
		return URLACTION_MODATTRIB;	
	}
	
	public function getFormType()
	{
		return FORMTYPE_ATTRIBUTE;	
	}
		
	/**
	 * This will return an associative array of data that should 
	 * be applied to whatever template system is being used.
	 * @return array An associative array of data
	 */
	function display ()
	{
				
		$data = array ();
		$attrib = new shAttribute;
				
		$this->addEditingTemplateData ($data,false);
		
		// First check if there's a cached object
		$id = $this->getUrlIdField();
		$obj = $this->recallFormData();
		$data['form_title'] = 'Add Tag';
		if (!$obj || ($obj->get(PROP_ID) != $id))
		{			
			// Is there an id in the url?  If so, then
			//	we are editing.			
			if ($id != '')
			{
				$data['form_title'] = 'Edit Tag';
				$attrib->set(PROP_ID,$id);
				if (!$attrib->load())
				{
					$this->addError (sprintf (str('STR_ATTRIB_NOTFOUND'), $id), ERROR_TYPE_SERIOUS);
				}
				else
				{
					$this->addEditingTemplateData ($data,true);
				}
			}
		}		
		
		if ($attrib)
		{
			$data['attribute_name'] = $attrib->get(PROP_NAME);
			$data['attribute_description'] = $attrib->get(PROP_DESCRIPTION);		
			$data['attribute_id'] = $attrib->get(PROP_ID);
			$data['attribute_type'] = $attrib->get(PROP_ATTRIBUTE_TYPE);
		}
		
		$smarty = app()->getSmartyObject();
		
		foreach ($data as $prop=>$value)
		{
			$smarty->assign($prop, $value);
		}
		
		$content = smarty_templ_fetch('forms/add_edit_attribute.tpl.html',$smarty);		
		$this->_page->addContent ($content);	
		
		return array();	
	}
	
	/**
	 * Override to implement form submit for this object
	 * @return bool Returns true if the form submission was successful 
	 */
	function submitForm ()
	{
		$attrib = new shAttribute;
		$attrib->set(PROP_NAME,$this->_page->getCleanFormArgument('attribute_name'));
		$attrib->set(PROP_DESCRIPTION,$this->_page->getCleanFormArgument('attribute_description'));
		$attrib->set(PROP_ATTRIBUTE_TYPE,$this->_page->getFormArgument('attribute_type'));
		
		$this->rememberFormData($attrib);
		
		if ($attrib->requiredFieldsValid())
		{
			if ($this->isEditingObject())
			{
				$attrib->set(PROP_ID,$this->_page->getFormArgument('attribute_id'));
				if ($attrib->update ())
				{
					$this->forgetFormData ();
					
					$this->addNotification (str('STR_ATTRIB_UPDATED'));
					return true;
				}
			}
			else
			{
				if ($attrib->add ())
				{
					$this->forgetFormData ();
					
					$this->addNotification (str('STR_ATTRIB_ADDED'));
					return true;
				}
			}
		}
		
		return false;		
	}

	function authorize ()
	{
		$id = $this->_page->getUrlArgument(URLARG_ID);
		if (!$id) 
		{
			$id = $this->_page->getFormArgument('attribute_id');
		}
		
		$user = app()->getLoggedInUserObject();
		return $user->getPermissions()->isAllowed(URLACTION_MODATTRIB,$id);
	}	
}
?>
