/**
 * Called when an object has been sent to the Nexus trashcan
 * @param {String} elementId The ID of the element that was sent to the trash
 */
function onItemSentToTrash(elementId)
{
	YAHOO.util.Dom.setStyle(elementId,'display','none');
}

/**
 * Called when an item was successfully renamed
 * @param {String} id The type of the item that was renamed (e.g. kNexusTypeDocument)
 * @param {String} id The ID of the item that was renamed
 * @param {String} id The new name of the item that was renamed
 */
function onItemRenamed(type, id, newName)
{
	var index = 
		gNexusObjectRegistry.findWithId(type, id);
		
	if (index > -1)
	{
		gNexusObjectRegistry.get(index).title = newName;
	}
}

/**
 * Called when an object has been sent to the Nexus trashcan
 * @param {String} elementId The ID of the element that was sent to the trash
 */
function onItemRemovedFromView(elementId)
{
	YAHOO.util.Dom.setStyle(elementId,'display','none');
}
