<?php
/*
 * Nexus is a web-based file management application.
 * Copyright (C) 2007 Karim Shehadeh
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
?>

<html>
<head>
<title>Nexus Installer</title>
<link href="install.css" rel="stylesheet" type="text/css" />
</head>
<body>
<h1>Nexus Installer</h1>

<?php
        
$gDynamicFolders = array (
    'cache/',
    'cache/smarty/',
    'cache/logs/',
    'cache/data/',
    'cache/data/db/',
    'cache/temp/',
    'cache/thumbs/',
    'cache/archives/',
    'files/library',
    'files/filebox',
    'files/',
    'config/'
);

//error_reporting (0);
error_reporting (E_ALL);

function write_dbinfo ($file, $host,$dbname,$user,$pass)
{
    $absPath = realpath($file);
    $configFile = 
"<?php
define ('DB_TYPE','mysql');
define ('DB_NAME','$dbname');
define ('DB_HOST','$host');
define ('DB_USER','$user');
define ('DB_PASS','$pass');
?>";
    
    $fh = fopen ($absPath, 'w+');
    if ($fh)
    {
        fwrite ($fh, $configFile);
        fclose ($fh);
        echo '<div class="success">Successfully created the dbconfig.php file with the given settings.</div>';
    }
    else {
        echo '<div class="error">Failed to write out the database config file (dbconfig.php).<br/>Before you can
                run Nexus, you must edit the config/dbconfig.php file with 
                the correct database information. </div>';
    }
}

function make_writable ($filename, $isdir)
{
    if (!file_exists ($filename))
    {
        if (!$isdir)
        {
            $fh = fopen ($filename, 'w+');
            if (!$fh) {
                echo '<div class="error">The following file could not be created: '.$filename.'</div>';
                return false;
            }
            
            fclose ($fh);
            return true;
        }
        else
        {
            echo '<div class="error">Directory not found: '.$filename.'</div>';
            return false;
        }
    }
    
    if (!is_writable ($filename))
    {
        // Now try to make the templates_c directory readable.
        $absPath = realpath ($filename);
        if ($absPath) {
            // Found absolute path now trying chmod
            if (!chmod ($absPath,0777))
            {
                // not a failure case, but let them know.
                echo '<div class="error">Failed to modify write permissions on: '.$absPath.'</div>';
                return false;
            }
        }
    }
    
    return true;
}

function populate_db($host, $user, $pass, $dbname, $sqlfile='database.sql') 
{
    $errors = array ();

    $link = mysql_connect ($host,$user,$pass);
    if (!$link)
    {
        echo '<div class="error">Failed to connect to the specified host: '.mysql_error().'</div>';
        return false;
    }
    
    if (!mysql_select_db($dbname, $link))
    {
        echo '<div class="error">Failed to find specified database name</div>';
        return false;
    }
    
    $mqr = @get_magic_quotes_runtime();
    @set_magic_quotes_runtime(0);
    $query = fread(fopen($sqlfile, "r"), filesize($sqlfile));
    @set_magic_quotes_runtime($mqr);
    $pieces  = split_sql($query);

    for ($i=0; $i<count($pieces); $i++) {
        $pieces[$i] = trim($pieces[$i]);
        if(!empty($pieces[$i]) && $pieces[$i] != "#") 
        {
            // Only do this if we support table name prefixes
            // $pieces[$i] = str_replace( "#__", $DBPrefix, $pieces[$i]);
            
            if (!$result = mysql_query ($pieces[$i])) {
                $errors[] = array ( mysql_error(), $pieces[$i] );
            }
        }
    }
    
    if (count ($errors) == 0)
    {
        return true;
    }
    else
    {
        foreach ($errors as $error) {
            echo '<div class="error"> DB Error: '.$error[0].'<div>'.$error[1].'</div></div>';        
        }
        return false;
    }
}

function split_sql($sql) 
{
    $sql = trim($sql);
    $sql = ereg_replace("\n#[^\n]*\n", "\n", $sql);

    $buffer = array();
    $ret = array();
    $in_string = false;

    for($i=0; $i<strlen($sql)-1; $i++) {
        if($sql[$i] == ";" && !$in_string) {
            $ret[] = substr($sql, 0, $i);
            $sql = substr($sql, $i + 1);
            $i = 0;
        }

        if($in_string && ($sql[$i] == $in_string) && $buffer[1] != "\\") {
            $in_string = false;
        }
        elseif(!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\")) {
            $in_string = $sql[$i];
        }
        if(isset($buffer[1])) {
            $buffer[0] = $buffer[1];
        }
        $buffer[1] = $sql[$i];
    }

    if(!empty($sql)) {
        $ret[] = $sql;
    }
    return($ret);
}

function tryWrite($path)
{
    $rootPath = '../../'.$path;
    if (!file_exists($rootPath))
    {
        if (!@mkdir($rootPath,0777,true))
        {
            echo '<div class="error">The path '.$path.' does not exist and could not be created</div>';
        }
        else
        {
            echo '<div class="success">The path '.$path.' did not exist but was created for you</div>';
        }
    }
    
    $success = false;
    $filepath = $rootPath.'/test.txt';
    
    $fp = @fopen($filepath,'w+');
    if ($fp)
    {        
        $count = @fwrite($fp,'test');
        if ($count > 0)
        {
            $success = true;
        }
        
        fclose($fp);
        if (!@unlink($filepath))
        {            
            // can't delete
            $success = false;
        }
    }
    
    return $success;
}

function doCompatibilityChecks()
{
    
    // PHP VERSION
    $phpversion = phpversion();
    $ver = explode('.',$phpversion);
    if ($ver[0] < 5)
    {
        die('<h2>Nexus requires PHP 5 or later - You are running PHP '.phpversion().'</h2>');
    }
    
    // FOLDERS WRITABLE
    $unwritables = array();
    foreach ($GLOBALS['gDynamicFolders'] as $folder)
    {
        if (!tryWrite($folder))
        {
            $unwritables[] = $folder;
        }
    }
    
    if (count ($unwritables) > 0)
    {
        die('The following directories must exist and be 
            writeable in order for Nexus to work 
            correctly:<br/><ul><li>'.
            implode('</li><li>',$unwritables).'</li></ul>');
    }
}

doCompatibilityChecks();

$submit = @$_POST['Submit'];
if ($submit)
{
    $hostname = @$_POST['host'];
    $dbase = @$_POST['dbase'];
    $user = @$_POST['user'];
    $pass = @$_POST['password'];
}
else
{
    $hostname = 'localhost';
    $dbase = 'db_nexus';
    $user = '';
    $pass = '';
}

$error = false;

if ($submit != '')
{
    $error = false;
    // an attempt was made - see if everything is okay
    if (!$hostname) {
        echo '<div class="error">You must specify a hostname (e.g. localhost)</div>';
        $error = true;
    }
    if (!$dbase) {
        echo '<div class="error">You must specify a database name(e.g. db_storystream)</div>';
        $error = true;
    }
    if (!$user) {
        echo '<div class="error">You must specify a database username (e.g. root)</div>';
        $error = true;
    }
    if (!$pass) {
        echo '<div class="error">You must specify a password</div>';
        $error = true;
    }
    
    if (!$error) {
        // Try to setup the database
        if (!populate_db ($hostname, $user, $pass,$dbase))
        {
            echo '<div class="error">Database install failed.</div>';
            $error = true;
        }
        else {

            echo '<div class="success">Nexus database tables were setup successfully</div>';

            if (!make_writable ('../../config/', true))
            {
                $error = true;
            }
            else 
            {            
                // only do this if we could make the config directory writeable.
                if (make_writable ('../../config/dbconfig.php', false))
                {                
                    // Write the configuration file
                    write_dbinfo ('../../config/dbconfig.php', $hostname, $dbase, $user, $pass);
                }
                else
                {
                    $error = true;
                    echo '<div class="error">Failed to write to the database config file: the config directory must have create permissions for the script user (0777, for example)</div>';
                }
            }

            if (!make_writable ('../../cache', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "cache" are set correctly</div>';
            }
            if (!make_writable ('../../cache/archives', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "cache/archives" are set correctly</div>';
            }
            if (!make_writable ('../../cache/logs', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "cache/logs" are set correctly</div>';
            }
            if (!make_writable ('../../cache/smarty', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "cache/smarty" are set correctly</div>';
            }
            if (!make_writable ('../../cache/data', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "cache/data" are set correctly</div>';
            }
            if (!make_writable ('../../cache/temp', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "cache/temp" are set correctly</div>';
            }
            if (!make_writable ('../../cache/thumbs', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "cache/thumbs" are set correctly</div>';
            }
            if (!make_writable ('../../files', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "files" are set correctly</div>';
            }
            if (!make_writable ('../../files/library', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "library" are set correctly</div>';
            }
            if (!make_writable ('../../files/filebox', true))
            {
                $error = true;
            }
            else 
            {
                echo '<div class="success">Permissions on "filebox" are set correctly</div>';
            }
            
        }
    }
}

if (!$submit)
{
    if (!is_writable ('../../config'))
    {
        echo '<div class="message">Note: Your database configuration folder is not writable.  The 
                installer will attempt to change that during installation, but not all servers 
                will allow scripts to change permissions on a folder.  To change the permissions yourself, 
                login to your server via FTP and change the file "[root]/config" to the correct 
                permissions (0777 is a safe bet).</div>';
    }
}
else {
    if ($error) {
        echo '<div class="message">Remember: You must address any <span class="error">red labeled</span> messages before proceeding</div>';
    }
    else {
        echo '<div> <a href="../../index.php">Click here</a> to visit your new Nexus site </div>';
    }
}

if (!$submit || $error){
?>
<link href="install.css" rel="stylesheet" type="text/css" />

<form action="index.php" method="post" name="frmDbInfo" target="_top">
    <table align="left" width="200" border="0">
        <caption>
            Database Information
        </caption>
        <tr>
            <td>Hostname</td>
            <td><input type="text" name="host" value="<?php echo $hostname?>"></td>
        </tr>
        <tr>
            <td>Database</td>
            <td><input type="text" name="dbase" value="<?php echo $dbase?>"></td>
        </tr>
        <tr>
            <td>User</td>
            <td><input type="text" name="user" value="<?php echo $user?>"></td>
        </tr>
        <tr>
            <td>Password</td>
            <td><input type="password" name="password" value="<?php echo $pass?>"></td>
        </tr>
        <tr>
            <td colspan="2"><label>
                <div align="center">
                    <input type="submit" name="Submit" value="Install">
                    </div>
            </label></td>
        </tr>
    </table>
</form>
<?php
}
?>
</body>
</html>
