<?php
/**
* name: Custom Start Page
* description: Allow the administrator to pick the start page for various access levels
* date: 4/1/6/2008
* version: 1.0
* author: iWonder Designs
*/

$GLOBALS['gStartActions'] = array(
                '',
                URLACTION_VIEWBIN,
                URLACTION_VIEWLIB,
                URLACTION_VIEWGROUP,
                URLACTION_VIEWCOMPANY,
                URLACTION_VIEWCAT,
                URLACTION_VIEWPOOL
                );

nx_register_handler('EVENT_PLUGIN_INIT','startpage_initialize');
nx_register_handler('EVENT_EXECUTE_ACTION_PRE_CONTENT','startpage_display_startpage_link');
nx_register_handler('EVENT_EXECUTE_ACTION_PRE','startpage_handle_set');
nx_register_handler('EVENT_FORM_REDIRECT_NEEDED','startpage_handle_redirect_login');          

function startpage_initialize()
{    
    // check to see that the user table is present
    $result = db()->Execute('select count(startpage_id) from sh_startpage_users');
    if (!$result)
    {
        // create the table.
        $result = db()->Execute('
            CREATE TABLE `sh_startpage_users` (
                `startpage_id` int(11) NOT NULL auto_increment,
                `username` varchar(255) NOT NULL,
                `url` varchar(255) NOT NULL,
                PRIMARY KEY  (`startpage_id`)
                ) ENGINE=InnoDB AUTO_INCREMENT=1 ;
            ');
            
        if (!$result)
        {
            $errObj = new iwError ('Startpage Plugin: Unable to create Startpage table in database');
            app()->addGlobalError($errObj);
            return false;
        }        
    }
    
    return true;
}
  
function startpage_get_user_startpage($username)
{
    $query = "select * from sh_startpage_users where username='$username'";
    $result = db()->GetRow($query);
    if ($result !== false)
    {
        $url = $result['url'];
        return $url;
    }
    
    return false;
}

function startpage_display_startpage_link($params)
{    
    global $gStartActions;
    
    $page = &$params['page'];
    if (in_array($params['action'],$gStartActions))
    {
        $showLink = true;
        $currentUrl = app()->_getURLWithParameters();
        
        $username = app()->getLoggedInUsername();
        $url = startpage_get_user_startpage($username);
        if ($url !== false)
        {            
            if ($currentUrl == $url)
            {
                $showLink = false;
            }        
        }
        
        if ($showLink)
        {            
            $page->addContent('<div class="startpage addlink"><a href="index.php?a=startpage_set&url='.base64_encode($currentUrl).'">Set As Startpage</a></div>');            
        }        
    }
}

function startpage_set_user_url($username,$url)
{
    $sp = startpage_get_user_startpage($username);            
    if (!$sp)
    {
        $query = "insert into sh_startpage_users (username,url) values ('$username','$url')";
    }
    else
    {
        $query = "update sh_startpage_users set username='$username',url='$url'";        
    }
    
    $rs = db()->Execute($query);
    if (!$rs)
    {
         return false;
    }
    
    return true;
}

function startpage_handle_set($params)
{
    $action = $params['action'];
    $page = &$params['page'];
    $continue = &$params['continue'];
    
    if (($action == 'startpage_set') && app()->isUserLoggedIn())
    {
        $url = base64_decode(g('url'));
        if ($url)
        {
            if (startpage_set_user_url(app()->getLoggedInUsername(),$url))
            {
                $page->addNotification('The new start page was set successfully');                
            }
            else
            {
                $page->addError('The new start page could not be set due to a database error');
            }
        }
        else
        {
            $page->addError("The custom start page could not be set because no URL was given");
        }
        $continue=false;
        app()->redirect($url);
    }
}

function startpage_handle_redirect_login($params)
{
    $form = &$params['form'];
    $link = &$params['link'];
    
    if ($form->getFormType() == FORMTYPE_LOGIN)
    {        
        $username = app()->getLoggedInUsername();
        $sp = startpage_get_user_startpage($username);        
        if ($sp != false)
        {            
            $link = $sp;
        }
    }
}
?>
